# Посібник із zUtilidades

* Автор: Héctor J. Benítez Corredera
* Сумісність з NVDA: з 2019.3 до 2021.1
* [Завантажити додаток:](https://nvda.es/files/get.php?file=zUtilidades)
* [Проєкт на GitHub:](https://github.com/hxebolax/zUtilidades-para-NVDA)

---

Зміст<a id="Índice"></a>
-------------
- [Вступ](#mark0)
- [Модуль Запуск програм](#mark1)
- [Головний екран](#mark2)
- [Список категорій](#mark3)
- [Список програм](#mark4)
- [Меню додати дію](#mark5)
- [Редагувати дію](#mark6)
- [Видалити дію](#mark7)
- [Кнопка меню](#mark8)
- [Гарячі клавіші](#mark9)
- [Примітки автора](#mark10)
- [Модуль Швидких нотаток](#mark11)
- [Додати коротку нотатку з будь-якого місця](#mark12)
- [Віртуальне меню для запуску програм і швидких нотаток](#mark13)
- [Перекладачі та співавтори](#mark14)
- [Історія змін](#mark15)
- [Версія 0.2.6](#mark0.2.6)
- [Версія 0.2.5](#mark0.2.5)
- [Версія 0.2.4](#mark0.2.4)
- [Версія 0.2.3](#mark0.2.3)
- [Версія 0.2.2](#mark0.2.2)
- [Версія 0.2.1](#mark0.2.1)
- [Версія 0.2](#mark0.2)
- [Версія 0.1.6](#mark0.1.6)
- [Версія 0.1.5](#mark0.1.5)
- [Версія 0.1](#mark0.1)

---

# Вступ<a id="mark0"></a>

zУтиліти — це набір невеликих програм для NVDA.

Ви можете додати програми, які можуть бути цікавими для вас, щоб ви могли швидко з ними ознайомитися, і які в той же час прості у використанні і мають зрозумілий інтерфейс.

zУтиліти матиме меню в Інструментах NVDA, у яке буде додано різні модулі.

Кожен модуль надається з можливістю додавання гарячих клавіш, для чого необхідно перейти в меню NVDA / Параметри / Жести вводу а потім знайти категорію zУтиліти.

Початково модулі надаються без призначених гарячих клавіш.

Таким чином, ви можете запускати модулі, перейшовши в меню Інструменти / zУтиліти або призначивши комбінацію клавіш для кожного модуля.

Наразі він складається з таких модулів:

* Запуск програм.
* Швидкі нотатки.

# Модуль запуску програм<a id="mark1"></a>

Цей модуль дозволить вам швидко та з будь-якого місця у Windows запускати програму – переносну чи встановлену.

## Головний екран<a id="mark2"></a>

Головний екран складається зі списку категорій, списку програм і кнопки «Меню».

Ви можете переміщатися між ними за допомогою клавіші Tab.

### Список категорій<a id="mark3"></a>

У цьому списку можна додати, змінити або видалити категорію, а також відсортувати програми за категоріями.

Ви можете отримати доступ до параметрів «Додати», «Редагувати» або «Видалити» двома способами.

В списку Категорій, натиснувши клавішу Контекстного меню або, якщо у вас немає клавіші  Контекстного меню Shift+F10, з'явиться меню, в якому ви можете вибрати один із трьох варіантів.

Діалогове вікно як для додавання, так і для редагування дуже просте, має єдине текстове поле, де ви можете ввести назву нової категорії або редагувати вибрану категорію, дві кнопки «Гаразд» та «Скасувати».

Якщо ви вирішите видалити, ви маєте розуміти, що те, що містить ця категорія, буде повністю видалено без можливості повторити дію, тому будьте обережні, ви можете втратити програми, які ви маєте в базі даних, і вам доведеться повторно вводити усі програми, команди чи доступи, які були в цій категорії.

Ви також можете отримати доступ до цих опцій за допомогою вкладки в кнопці Меню, або натиснувши комбінацію клавіш Alt+M. Якщо ви зробите це, з'явиться меню з підменю "Категорії", де ви можете вибрати один з трьох попередніх варіантів.

Зауважте, що редагування та видалення завжди відбуватиметься у тій категорії, яка знаходиться у фокусі, з видачею відповідних повідомлень у разі, якщо ви не маєте категорій.

Ви також можете використовувати комбінації клавіш Alt + Стрілка вгору та Стрілка вниз для переміщення категорії в порядку їх сортування.

### Список програм<a id="mark4"></a>

У цьому списку будуть розміщені програми, які відповідають вибраній вами категорії.

У вас є 3 варіанти: Додати дію, Змінити дію або Видалити дію.

Ви можете отримати ці варіанти в списку категорій, або натиснувши клавішу Контекстного меню або Shift+F10, або перейшовши до кнопки Меню (Alt+M) та знайшовши підменю Програми.

У цьому списку програм ви можете запустити програму, яка знаходиться у фокусі, натиснувши клавішу Пробіл.

Ви також можете використовувати комбінації клавіш Alt + Стрілка вгору та Стрілка вниз для переміщення записів у порядку їх сортування.

У цьому списку ви можете швидко переглянути різні записи, натиснувши на першу літеру, щоб швидко знайти програму, яку ви хочете запустити, якщо у вас їх багато в базі даних.

#### Меню додати дію<a id="mark5"></a>

У цьому меню ви можете вибрати один із таких варіантів:

* Додати програму:

Якщо ви додаєте програму, є два поля, які є обов'язковими, це ім'я програми та каталог, в якому знаходиться програма.

Поки що додаток підтримує програми з розширеннями exe, bat і com.

Після заповнення обов’язкових полів ви можете вибрати, чи потребує програма додаткових параметрів, чи ви хочете запустити програму в режимі адміністратора.

Якщо ви бажаєте запустити програму в режимі адміністратора, при запуску програми вам потрібно буде надати відповідний дозвіл. 

* Додати команду CMD

У цьому діалозі ви можете додати команди консолі.

Ім'я поля для ідентифікації команди та поле команди є обов'язковими.

Кілька приміток: окрім запуску команд cmd, якщо ви освоїли Windows PowerShell, ви також запускатимете команди PowerShell, якщо розмістите PowerShell у командному рядку, а потім будете виконувати те, що хочете.

Аналогічно, якщо це команди CMD, автор додає, що ви можете виконати кілька рядків, які мають бути розділені символом (амперсанд), що досягається за допомогою Shift+6, це в іспанській QWERTY клавіатурі. Якщо використовується англійська клавіатура QWERTY, це буде зроблено за допомогою Shift+7.

Ось приклад командного рядка для перезапуску провідника Windows, ви помітите, що автор використовує символ (амперсенд), щоб відокремити один командний рядок від іншого.

`taskkill /f /im explorer.exe & start explorer`

Також у цьому діалозі ви можете встановити паузу, щоб консоль не закривалася і ви могли бачити результати.

Ви також можете працювати від імені адміністратора.

* Додавання доступу до папок

У цьому діалозі нам потрібно буде вибрати ім'я для ідентифікації доступу до папки та вибрати папку.

Це дозволить вам швидко відкривати системні папки з будь-якого місця.

* Додати ярлики запуску Windows

У цьому діалозі ви можете вибрати ярлик для запуску. Ви також можете вибрати, чи хочете ви запустити його від імені адміністратора.

Поля для визначення імені ярлика та шляху є обов’язковими.

* Додати встановлену програму

У цьому діалозі ви отримаєте всі програми, встановлені на комп'ютері або користувачем, або програми, які вже постачаються з Windows.

Також на цьому екрані ви можете вибрати програми, встановлені з магазину Windows.

Зверніть увагу, це не стосується Windows 7.

Після додавання програми з цього діалогу її не може бути відредаговано, і вам доведеться видалити запис, якщо ви хочете додати його знову.

Опція адміністратора у цьому діалоговому вікні працюватиме не для всіх програм. Вона працюватиме лише для додатків, які дозволяють підвищувати привілеї адміністратора.

Також зверніть увагу, що в цьому діалозі в комбінованому списку також з'являться ярлики встановлених програм, ви зможете вибрати їх, але деякі можуть не відкритися, видаючи помилку.

Варто також зазначити, що ви повинні бути обережними, тому що в цьому списку ви знайдете додатки, які можуть бути для адміністрування або керування комп'ютером, тому, якщо ви не знаєте, для чого вони потрібні, краще їх не чіпати.

#### Редагування дії<a id="mark6"></a>

Діалогове вікно «Редагувати» точно таке ж, як і діалогове вікно «Додати дію», але воно дозволить вам змінювати вибрані вами дані.

Це дозволить вам змінити всі елементи, крім тих, які були додані опцією Додати встановлену програму, діалоги будуть такими ж, як і в опціях додавання.

#### Видалити дію<a id="mark7"></a>

Якщо ви видаляєте запис, ви повинні врахувати, що ця дія буде незворотною.

### Кнопка меню<a id="mark8"></a>

Ця кнопка буде доступна з будь-якої частини інтерфейсу, натиснувши комбінацію Alt+M.

У цьому меню знаходяться чотири підменю: Категорії, Дії, Створення або відновлення резервних копій та Параметри, в цьому меню також є опція Вихід.

Про категорії та дії вже було розказано, тому далі йтиметься про підменю "Створення та відновлення резервних копій" та "Параметри".

Що ж, якщо ви вибираєте Створити резервну копію, відкриється вікно збереження Windows, у якому вам потрібно буде вибрати, куди зберегти резервну копію бази даних.

За замовчуванням ім’я файлу виглядає приблизно так:

`Backup-03052021230645.zut-zl`

Розширення встановлено за замовчуванням, а ім'я відповідає модулю і містить дату його створення, ви можете поставити ім'я, яке хочете.

Після збереження ви можете відновити її, якщо ваша база даних буде пошкоджена або просто ви видалите її помилково, або хочете повернутися до версії, яку ви зберегли.

Потім виберіть Відновити резервні копії та відкриється класичне вікно Windows, щоб відкрити файли.

Ви повинні вибрати копію, яку ви зберегли, яка матиме розширення *.zut-zl. Будьте обережні, щоб не змінити розширення, інакше ви не знайдете файл.

Після вибору резервну копію буде відновлено, і коли ви натиснете кнопку «Гаразд», додаток закриється і наступного разу, коли ви його відкриєте, вашу копію буде відновлено.

Зауважте, що файли *.zut-zl насправді є стиснутими файлами, але будьте обережні зі зміною, тому що якщо вони будуть змінені, підпис не буде відповідати, і це не дозволить вам відновити їх.

Під цим автор має на увазі, що ці файли мають підпис, який, якщо він не збігається під час відновлення, завершиться помилкою, і кожен підпис для кожного файлу відрізняється.

У підменю «Параметри» тепер є лише параметр «Повернутися до початкових значень панелі запуску програм».

Якщо ви виберете цей параметр, усю базу даних буде видалено, а додаток залишиться таким, ніби він був нещодавно встановлений.

## Гарячі клавіші<a id="mark9"></a>

У двох областях, як у категоріях, так і в додатках, ми можемо впорядкувати записи за такими параметрами:

* Alt + стрілка вгору або стрілка вниз

Коли категорія або програма досягає початку або кінця, вона повідомляє про це характерним звуком, щоб дати вам знати, що ви не можете йти далі вгору чи вниз.

* Alt + C: дозволить вам швидко перейти до області категорій.

* Alt + L: дозволить швидко перейти до списку програм.

* Alt + M: Відкриває меню.

* Клавіша Контекстного меню або Shift + F10: В області категорій та програм відображає контекстне меню з опціями.

* Пробіл: В області списку програм буде запущено ту програму, яка знаходиться у фокусі.

* Вихід: закриває всі діалогові вікна, які програма може відкрити, включно з головним екраном засобу запуску програм, залишаючи фокус з того місця, де його викликали.

## Примітки автора<a id="mark10"></a>

Перша полягає в тому, що Запуск програм закриється, коли ви запустите програму, і вам доведеться викликати його знову, коли ви захочете запустити іншу програму.

А також реалізована функція, яка зберігає положення категорії та останньої відвіданої програми, тому при відкритті Запуск програм завжди буде обрано останню категорію та останній додаток у цій категорії.

Було також реалізовано збереження фокуса, тому, коли ви викликаєте запуск програм, вона завжди залишатиме вас в останньому положенні, де був фокус перед закриттям.

Наприклад, якщо фокус перебуває на кнопці «Меню», а ви закриваєте панель запуску програм, наступного разу, коли ви її відкриєте, фокус буде на кнопці «Меню».

Ці функції діють під час сесії NVDA, тобто, якщо ви перезапустите NVDA, то почнете з фокусу в області категорій.

Цей додаток створено для використання у Windows 10, тому якщо ви використовуєте старіші версії і у вас виникли проблеми, будь ласка, дайте автору знати, але він, ймовірно, не зможе нічого зробити, оскільки деякі функції доступні лише у Windows 10.

# Модуль швидких нотаток<a id="mark11"></a>

Цей модуль допоможе вам мати під рукою невеликі нотатки, які ви можете переглядати, редагувати, видаляти.

Цей модуль має таку саму обробку, як і модуль запуску програм, але відрізняється деякими клавішами, поясненими нижче.

Не будемо пояснювати меню, за допомогою якого ви можете робити резервні копії, відновлювати їх, повертати додаток до початкових значень, керувати категоріями та нотататками.

Також не будемо знову пояснювати основний інтерфейс, оскільки він іденнтичний.

Ви можете додати швидку нотатку, а в діалоговому вікні, що відкриється, ви можете вказати заголовок нотатки та додати вміст до неї.

Діалог редагування нотатки такий самий, ви можете додати заголовок або змінити існуючий і відредагувати нотатку.

Цей модуль відрізняється від модуля запуску додатків тим, що він використовує деякі нові комбінації клавіш.

* F1: коли нотатка знаходиться у фокусі, при натисканні F1, вам буде прочитано вміст нотатки.
* F2: скопіює сфокусовану нотатку в буфер обміну, щоб ви могли вставити її куди завгодно, за умови, що програма, яка підтримує запис, має бути сфокусована, інакше нічого не станеться.
* F3: Ця комбінація закриє вікно швидких нотаток і вставить вміст нотатки, що знаходиться у фокусі, тобто вставить нотатку у відкриту програму, якщо вона дозволяє вставити текст, наприклад, у Блокнот, поле електронної пошти, Word і т.д.

Це означає, що якщо ви викликаєте модуль швидких нотаток із Блокноту або теми електронної пошти, коли ви натискаєте цю комбінацію, текст буде вставлено туди, де був фокус.

Наприклад, якщо запустити модуль Швидких нотаток з робочого стола і натиснути F3 на нотатці, нічого не станеться, а якщо відкрити Блокнот і натиснути F3, то вміст нотатки буде вставлено в Блокнот.

Будьте уважні, якщо ви знаходитесь на робочому столі або в місці, де ви не можете вставити його безпосередньо, це нічого не дасть.

Він також продовжує працювати як в області категорій, так і в області списку нотаток, маючи можливість упорядкувати ці області за допомогою Alt+стрілки вгору та вниз, щоб перемістити те, що ви вибрали.

Якщо ви натиснете пробіл, відкриється вікно, де ви зможете лише переглянути нотатку.

Слід зазначити, що цей модуль надається без певної гарячої клавіші, тому вам доведеться додати її у Жестах вводу.

До меню «Параметри» додано діалогове вікно «Параметри».

Поки що він має тільки один варіант, який виглядає таким чином:

* Захоплення заголовка вікна у швидких нотатках (з будь-якого місця)

Якщо ви позначите цей параметр під час натискання кнопки «Додати нову коротку нотатку» або «Додати коротку нотатку» до вибраного тексту, заголовок нотатки буде заповнено назвою вікна, яке наразі вибрано.

# Додати швидку нотатку з будь-якого місця<a id="mark12"></a>

Також у модулі швидких нотаток є функція додавання швидких нотаток із будь-якого місця без необхідності відкривати додаток.

У діалозі Жести вводу ви можете налаштувати нову комбінацію клавіш, яку ви знайдете у розділі:

NVDA / Налаштування / Жести вводу / zУтиліти / Одним клацанням додається швидка нотатка до вибраного тексту, подвійним клацанням додається нова коротка нотатка

Після того, як ви призначили комбінацію, вам залишається лише виділити текст у будь-якому місці та натиснути комбінацію клавіш.

Відкриється вікно, в якому насамперед потрібно буде вибрати категорію, в якій ви хочете зберегти нотатку, з'являться лише ті категорії, які ви додали.

При табуляції ви потрапите в поле для розміщення заголовка нотатки, а при повторній табуляції з'явиться текст, який ви виділили.

Якщо ви натиснете «Гаразд», він буде збережений, і ви отримаєте нотатку у вибраній категорії.

При подвійному натисканні на цю комбінацію відкриється той самий екран, але додавання нотатки з нуля. Вам потрібно буде вибрати, в якій категорії зберегти нотатку, назву нотатки, а також її вміст.

# Віртуальне меню для запуску програм та для швидких нотаток<a id="mark13"></a>

Ці меню розширюють можливості zУтиліти, роблячи його набагато продуктивнішим та швидшим.

Жести, які ви призначили для запуску програм і швидких нотаток, тепер мають подвійне натискання.

Якщо натиснути цю комбінацію один раз, з’явиться графічний інтерфейс, якщо натиснути двічі, з’явиться віртуальне меню.

У цьому меню ви можете переміщатися між категоріями за допомогою стрілок вправо та вліво, а також стрілок вгору та вниз між елементами зазначеної категорії, якщо такі є.

Між меню запуску програм та меню швидких нотаток є деякі відмінності.

У меню запуску віртуальних програм використовуйте клавіші зі стрілками для переміщення та натисніть Enter, щоб виконати вибраний пункт і зробити відповідну дію.

Якщо це команда cmd, він запустить її, якщо це ярлик, він запустить його, і так далі, ніби це був графічний інтерфейс.

За допомогою Escape ви залишите меню, якщо не хочете нічого робити.

Ви також можете переміщатися за категоріями, натискаючи клавіші початку назви, крім ñ, яка не підтримується цим меню, решта клавіш швидко приведе нас до категорії.

Якщо ця літера не має категорії, вона видасть нам довідкове повідомлення а також якщо ми натиснемо будь-яку іншу клавішу, відмінну від перерахованих вище.

Варто зазначити, що доки меню активне, всі інші комбінації клавіш NVDA не працюватимуть до виходу з меню.

У меню швидких нотаток клавіша пробілу марна, якщо вона відрізняється від засобу запуску програм.

Коли елемент знаходиться у фокусі, якщо ви натиснете F1, він озвучить зміст нотатки, за допомогою F2 він скопіює нотатку в буфер обміну, а за допомогою F3 він вставить вміст нотатки туди, де ви знаходитесь у фокусі.

Аналогічно, поки меню активне, воно має пріоритет доти, доки не буде натиснуто клавішу Escape для виходу з меню та відновлення нормальної функціональності клавіатури.

## Перекладачі та співавтори:<a id="mark14"></a>

* Ukrainian: Heorhii
* Francés: Rémy Ruiz
* Portugués: Ângelo Miguel Abrantes
* Italiano: Alessio Lenzi
* Ruso: Valentin Kupriyanov
* Turco: Umut KORKMAZ
* Árabe: Wafiq Taher
* Javi Domínguez: Mil gracias por enseñarme a programar el menú. Mejor dicho por explicarlo para tontos como yo.

# Журнал змін.<a id="mark15"></a>
## Версія 0.2.6.<a id="mark0.2.6"></a>.

* Додано данську мову.

* Виправлено проблему з брайлівськими рядками й показом повідомлень.

* Додано підтримку NVDA 2023.1.

## Версія 0.2.5.<a id="mark0.2.5"></a>

* Виправлено помилку безпеки на захищених екранах.

* Виправлено проблему з перезавантаженням додатка в NVDA.

## Версія 0.2.4.<a id="mark0.2.4"></a>

* Додана можливість захопити URL-адресу в короткій нотатці.

Налаштування параметрів модуля Швидких нотаток.

* Додано російську та турецьку мови.

* Виправлено ​​помилку з внутрішніми шляхами NVDA.

* Виправлено ​​помилку на клавіатурах з кириличними символами.

* Сумісність із NVDA 2022.1.

## Версія 0.2.3.<a id="mark0.2.3"></a>

Додана можливість захоплення заголовка вікон Додати нову швидку замітку або Додати швидку замітку з виділеного тексту.

Цю опцію можна активувати в меню модуля Швидкі нотатки у розділі Параметри.

Якщо прапорець встановлено, відображатимуться заголовки вікон, з яких були викликані команди Додати нову швидку нотатку або Додати швидку нотатку виділеного тексту.

## Версія 0.2.2.<a id="mark0.2.2"></a>

* Додано можливість переміщення між категоріями для елементів запуску додатків та нотаток.
* Додано подвійне натискання для клавіші «Додати швидку нотатку» до вибраного тексту. Тепер подвійне клацання дозволить нам створити нову коротку нотатку з нуля.
* Оновлена ​​документація французькою мовою.
* Додано італійську мову.

## Версія 0.2.1.<a id="mark0.2.1"></a>

* Виправлена ​​проблема з порожнім буфером обміну під час спроби вставити текст.

## Версія 0.2.<a id="mark0.2"></a>

* Виправлено багато внутрішніх помилок.
* Модуль запуску програм стабілізовано.
* Додано новий модуль Швидкі нотатки.
* Для двох модулів додано віртуальні меню.

## Versión 0.1.6.<a id="mark0.1.6"></a>

* Agregado idioma Francés y  Portugués (Portugal / Brasil).

## Versión 0.1.5.<a id="mark0.1.5"></a>

* Restructurados los menús.

Agregado la posibilidad de añadir:

* Añadir comando CMD

* Añadir accesos a carpetas

* Añadir ejecutar accesos directos de Windows

* Añadir aplicación instalada

* Se agrego en el botón Menú la posibilidad en Opciones Volver a valores por defecto el lanzador de aplicaciones

* Se corrigieron distintos errores con la base de datos.

* Se corrigieron errores internos.

* Se preparo el complemento para ser traducido.

## Versión 0.1.<a id="mark0.1"></a>

* Agregado modulo Lanzador de aplicaciones

* Versión inicial.

